public class MTPSchema{
	private int[][] schema;

	private static int numeroCasuale(){
		return(int)(Math.random()*5+1);
	}

	public MTPSchema(int n){
		this.schema= new int[n][n];
		for(int i=0; i<n; i++)
			for(int j=0; j<n; j++)
				this.schema[i][j]=MTPSchema.numeroCasuale();
	}

	public boolean muoviElemento(int i, int j, int h, int k){
		boolean scambiato=false;
		int m=this.schema.length;
		int n=this.schema[0].length;
		if(i>=0 && i<m && j>=0 && j<n && h>0 && h<m && k>0 && k<n){ // indici validi
			if((i==h && (k==j+1 || k==j-1)) || (j==k && (h==i+1 || h==i-1))){
				scambiato=true;
				int tmp=this.schema[i][j];
				this.schema[i][j]=this.schema[h][k];
				this.schema[h][k]=tmp;
			}
		}
		return scambiato;
	}

	public int[] maxSequenzaOrizzontale(int i, int j){
		int[] indici=new int[2];
		int h=j;
		while(h>0 && this.schema[i][h]==this.schema[i][h-1])
			h--;
		indici[0]=h;
		h=j;
		while(h<this.schema[0].length-1 && this.schema[i][h]==this.schema[i][h+1])
			h++;
		indici[1]=h;
		return indici;
	}

	public String toString(){
		String str="";
		for(int i=0; i<this.schema.length; i++){
			for(int j=0; j<this.schema[0].length; j++)
				str+= this.schema[i][j]+" ";
			str+="\n";
		}
		return str;
	}

}